document.observe('dom:loaded', function(){

  var QrCodeInitializer = Class.create({

    options: {
      width		: 210,
      height		: 210,
      typeNumber	: -1,
      correctLevel	: QRErrorCorrectLevel.H
    },
  
    initialize: function() {
      var url = window.location.href.split('/');
      url = [url[0], url[2]].join('//');
      key = $('api-access-key').innerHTML;
      this.options.text = Object.toJSON({url: url, key: key});

      var element	= Prototype.Browser.IE ? this.createTable() : this.createCanvas();
      element = new Element('div', {
        style: 'margin-top:5px'
      }).insert(element);
      $('api-access-key').insert(element);
    },


    createCanvas: function(){
      // create the qrcode itself
      var qrcode	= new QRCode(this.options.typeNumber, this.options.correctLevel);
      qrcode.addData(this.options.text);
      qrcode.make();

      // create canvas element
      var canvas	= document.createElement('canvas');
      canvas.width	= this.options.width;
      canvas.height	= this.options.height;
      var ctx		= canvas.getContext('2d');

      // compute tileW/tileH based on options.width/options.height
      var tileW	= this.options.width  / qrcode.getModuleCount();
      var tileH	= this.options.height / qrcode.getModuleCount();

      // draw in the canvas
      for( var row = 0; row < qrcode.getModuleCount(); row++ ){
        for( var col = 0; col < qrcode.getModuleCount(); col++ ){
          ctx.fillStyle = qrcode.isDark(row, col) ? "#000000" : "#ffffff";
          ctx.fillRect( col*tileW, row*tileH, tileW, tileH );
        }
      }
      // return just built canvas
      return canvas;
    },

    createTable: function(){
      // create the qrcode itself
      var qrcode	= new QRCode(this.options.typeNumber, this.options.correctLevel);
      qrcode.addData(this.options.text);
      qrcode.make();

      // create table element
      var table = new Element('table')
        .setStyle({
          'width': this.options.width+"px",
          'height': this.options.height+"px",
          'border': "0px",
          'border-collapse': "collapse",
          'background-color': "#ffffff"
        });


      // compute tileS percentage
      var tileW	= this.options.width / qrcode.getModuleCount();
      var tileH	= this.options.height / qrcode.getModuleCount();

      // draw in the table
      for(var row = 0; row < qrcode.getModuleCount(); row++ ){
        var row_elemet = new Element('tr')
          .setStyle({ height: tileH+"px" });
        for(var col = 0; col < qrcode.getModuleCount(); col++ ){
          row_elemet.insert(
            new Element('td')
              .setStyle({
                width: tileW+"px",
                'background-color': qrcode.isDark(row, col) ? "#000000" : "#ffffff"
              })
          );
        }
        table.insert(row_elemet);
      }
      // return just built canvas
      return table;
    }


  });

  new QrCodeInitializer();

});